<template>
  <div class="mode-selector">
    <h2 class="mode-selector__title">Mode selector</h2>
    <div class="mode-selector__cta mode-selector-cta">
      <div class="mode-selector-cta__item mode-selector-cta-item">
        <h3 class="mode-selector-cta-item__subtitle">Live mode</h3>
        <p class="mode-selector-cta-item__text">Characters are requested to the API per page</p>
        <p class="mode-selector-cta-item__text">Filtering is done by the API</p>
        <p class="mode-selector-cta-item__text">Sort is only available inside the current page carachters</p>
        <app-button class="mode-selector-cta-item__button" theme="lanister" @button-click="fetchCharacters()">Live mode</app-button>
      </div>
      <div class="mode-selector-cta__item mode-selector-cta-item">
        <h3 class="mode-selector-cta-item__subtitle">Prefetch mode</h3>
        <p class="mode-selector-cta-item__text">All characters are requested to the API at start</p>
        <p class="mode-selector-cta-item__text">Filtering is done in the frontend</p>
        <p class="mode-selector-cta-item__text">Sorting works between all characters</p>
        <app-button class="mode-selector-cta-item__button" theme="starks" @button-click="prefetchAllCharacters()">Prefetch mode</app-button>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapActions } from 'vuex';
import { AppMode } from '@/types';

// Components
import AppButton from '@/components/AppButton.vue';

export default Vue.extend({
  name: 'ModeSelector',

  components: {
    AppButton
  },

  methods: {
    ...mapActions([
      'getAllCharacters',
      'getCharacters',
      'setAppMode'
    ]),

    /**
     * Fetch the first page of characters and set the application mode to live.
     */
    fetchCharacters () {
      this.setAppMode(AppMode.live);
      this.getCharacters();
    },

    prefetchAllCharacters () {
      this.setAppMode(AppMode.prefetch);
      this.getAllCharacters();
    }
  }
});
</script>

<style lang="scss" scoped>
.mode-selector {
  &__title {
    margin-bottom: 2rem;
    text-align: center;
    font-size: 2rem;
  }
}

.mode-selector-cta {
  display: flex;
  justify-content: center;
  gap: 3rem;
}

.mode-selector-cta-item {
  display: flex;
  flex-direction: column;

  &__subtitle {
    margin: 0 auto 1rem;
  }

  &__button {
    margin: 2rem auto 0;
  }
}
</style>
